unit MainForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, JSDialog, JSEditDialog, JSDialogs, StdCtrls;

type
  TfrmMain = class(TForm)
    jsedSettings: TJSEditDialog;
    Button1: TButton;
    ListBox1: TListBox;
    procedure Button1Click(Sender: TObject);
    procedure jsedSettingsGetEditControlClass(Sender: TObject;
      const Index: Integer; var ControlClass: TControlClass);
    procedure jsedSettingsGetEditValue(Sender: TObject; AControl: TControl;
      const Index: Integer; var Value: string);
    procedure jsedSettingsControlClick(Sender: TObject;
      ControlType: TControlType; Control: TControl; const Value: Integer;
      var Handled: Boolean);
  private
    function UpdateFormSettings(AControl: TControl): string;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

uses SettingsFrame;

{$R *.dfm}

procedure TfrmMain.Button1Click(Sender: TObject);
begin
  if jsedSettings.Execute = mrOK then
  begin
    Caption := jsedSettings.EditValue;
  end;
end;

procedure TfrmMain.jsedSettingsControlClick(Sender: TObject;
  ControlType: TControlType; Control: TControl; const Value: Integer;
  var Handled: Boolean);
var
  LControl: TControl;
begin
  if ControlType = ctCommandlink then
  begin
    if Value = BASE_CUSTOMBUTTON then
    begin
      LControl := TJSEditDialog(Sender).EditControls[0];
      Caption := UpdateFormSettings(LControl);
      Handled := True;
    end;
  end;
end;

procedure TfrmMain.jsedSettingsGetEditControlClass(Sender: TObject;
  const Index: Integer; var ControlClass: TControlClass);
begin
  ControlClass := TfrSettings;
end;

function TfrmMain.UpdateFormSettings(AControl: TControl): string;
var
  LSettings: TfrSettings;
  I: Integer;
begin
  LSettings := TfrSettings(AControl);
  if LSettings.rbSettingOne.Checked then
    Result := LSettings.eSettingOne.Text
  else
    Result := 'n/a';
  ListBox1.Items.Clear;
  for I := 0 to LSettings.clbAdditionalOptions.Items.Count - 1 do
  begin
    if LSettings.clbAdditionalOptions.Checked[I] then
      ListBox1.Items.Add(LSettings.clbAdditionalOptions.Items[I]);
  end;
  case LSettings.cboxListItems.ItemIndex of
    0: Color := clBtnFace;
    1: Color := clWhite;
    2: Color := clYellow;
    3: Color := clLime;
  end;
end;

procedure TfrmMain.jsedSettingsGetEditValue(Sender: TObject; AControl: TControl;
  const Index: Integer; var Value: string);
begin
  if TJSEditDialog(Sender).ModalResult = mrOK then
  begin
    Value := UpdateFormSettings(AControl);
  end;
end;

end.
